Attribute VB_Name = "SpecAnalyzer"
': Spectrum Analyzer
'.:  
': 1.09
':   
':  
'e-mail: rashid_aliyev@ yahoo.com
'URL: http://rashid4ever.narod.ru/myapps/
':  99%  :)
'---------------------------------
'          
'   
'  , ,      
'    "winmm.dll"
'-----------------------------------------
'     ,     
'-----------------------------------------
':       ,
'  1024  800 (  )

Option Explicit '    :)

'  
Public hWaveIn& '  
Private bBufferFull As Boolean '   (); /
Private WaveData(255) As Byte ' 

Type WAVEFORMATEX '    
     wFormatTag As Integer '   ()
     nChannels As Integer ' 
     nSamplesPerSec As Long '   (/)
     nAvgBytesPerSec As Long '   .
     nBlockAlign As Integer ' 
     wBitsPerSample As Integer '/
     cbSize As Integer ' 
End Type

Type WAVEHDR '   (/)
     lpData As Long ' ()
     dwBufferLength As Long '  ()
     dwBytesRecorded As Long ' 
     dwUser As Long '  
     dwFlags As Long '   ()
     dwLoops As Long '
     lpNext As Long ' 
     Reserved As Long ' 
End Type

Type WAVEINCAPS '  
     wMid As Integer '
     wPid As Integer ' (Peak)
     vDriverVersion As Long '  ()
     szPname As String * 32 '  (/)
     dwFormats As Long ' 
     wChannels As Integer ' 
End Type

'    
'   ,   
Declare Function waveInAddBuffer Lib "winmm.dll" (ByVal hWaveIn As Long, lpWaveInHdr As WAVEHDR, ByVal uSize As Long) As Long
'    (0  )
Declare Function waveInGetNumDevs Lib "winmm.dll" () As Long
'  
Declare Function waveInOpen Lib "winmm.dll" (lphWaveIn As Long, ByVal uDeviceID As Long, lpFormat As WAVEFORMATEX, ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal dwFlags As Long) As Long
'  ()
Declare Function waveInPrepareHeader Lib "winmm.dll" (ByVal hWaveIn As Long, lpWaveInHdr As WAVEHDR, ByVal uSize As Long) As Long
'  
Declare Function waveInReset Lib "winmm.dll" (ByVal hWaveIn As Long) As Long
'  
Declare Function waveInStart Lib "winmm.dll" (ByVal hWaveIn As Long) As Long
'    
Declare Function waveInStop Lib "winmm.dll" (ByVal hWaveIn As Long) As Long
'  
Declare Function waveInClose Lib "winmm.dll" (ByVal hWaveIn As Long) As Long
' () 
Declare Function waveInUnprepareHeader Lib "winmm.dll" (ByVal hWaveIn As Long, lpWaveInHdr As WAVEHDR, ByVal uSize As Long) As Long
' 
Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Public Const CALLBACK_FUNCTION = &H30000 ' 
Public Const MM_WIM_DATA = &H3C0 '  
Public Const WAVE_FORMAT_PCM = 1 '  (1  .)
Public Const WAVE_MAPPER = -1& 'Wave Mapper     

' () 
Public Const WAVE_FORMAT_1M08 = &H1   ' 11025 , 8 , .
Public Const WAVE_FORMAT_2M08 = &H10  ' 22050 , 8 , .
Public Const WAVE_FORMAT_4M08 = &H100 ' 44100 , 8 , o.

' 
Global Const HWND_TOP = 0       '    
Global Const HWND_TOPMOST = -1  '  
Global Const HWND_NOTOPMOST = -2 '    (   )
Global Const SWP_NOMOVE = 2     ' 
Global Const SWP_NOSIZE = 1     '  
Global Const FLAGS = SWP_NOMOVE Or SWP_NOSIZE '
Private Sub Main()
'   
#If Win32 Then '  32- 
    If PrevInst Then End '      
    If Not WaveInPresent Then End '    ,  
    frmMain.Show '  
#Else '   (   32  16)
    End '     
#End If
End Sub
Private Function PrevInst() As Boolean
'    ,     
If App.PrevInstance Then
    MsgBox "    " & App.Title & "." & vbCrLf & "    .", vbExclamation + vbMsgBoxSetForeground
    PrevInst = True
Else '    
    PrevInst = False
End If
End Function
Private Function WaveInPresent() As Boolean
'   
If waveInGetNumDevs() > 0 Then '     
    WaveInPresent = True '   
Else '  
    '   
    MsgBox "     ." & _
    vbCrLf & "        ." _
    , vbCritical, "  " & App.Title
    WaveInPresent = False ' ,    ( )
End If
End Function
Public Sub waveInProc(ByVal hwi&, ByVal uMsg&, ByVal dwInstance&, ByVal dwParam1&, ByVal dwParam2&)
'!
'       .
'      .

' :  ()  
If uMsg = MM_WIM_DATA Then bBufferFull = True

End Sub
Private Sub DrawSpect()
'  (  ,   pctSpec)
'x% -    ( )
'c% -      (  )
'i% -      
Dim X%, c%, i%, j%, q%, t, d, r, tX, tY, tmp
frmMain.pctSpec.Cls '       
For X% = 0 To 254 '     254 (  255?)
c% = WaveData(X%) '  ,    
    '        
    With frmMain
        t = t - 0.05
        r = t + c% * 3.14159 * 4
        d = c% / 2
        tX = Cos(r) * d
        tY = Sin(r) * d
        Select Case .cmbStyle.ListIndex
            Case 0 ' (/)
                .pctSpec.Line (X%, c%)-(X%, 256), Col(c%)
            Case 1 ' -   :    
                .pctSpec.Line (X%, c%)-(X%, 128), Col(c%)
            Case 2 ' -     
                .pctSpec.PSet (X%, c%), Col(c%)
            Case 3 ' -         
                .pctSpec.Line -(X%, c%), Col(c%)
            Case 4 '
                .pctSpec.Circle (X%, c%), 2, Col(c%)
            Case 5 '
                .pctSpec.PSet (X%, 112 - c% / 3), vbYellow
                .pctSpec.PSet (X%, c% / 3 + 144), vbCyan
            Case 6 ' (   )
                .pctSpec.Line (X%, 128 - c% / 2)-(X%, c% / 2 + 128), Col(c%)
            Case 7 '
                .pctSpec.Line (X%, 0)-(X%, c%), Col(c%)
            Case 8 '
                .pctSpec.Line -(X% * 2, c%), Col(c%), B
            Case 9 ' ()
                .pctSpec.Line -(c%, X%), Col(c%)
            Case 10 '
                .pctSpec.Line (X%, 128)-(X% + 10, c%), Col(c%)
            Case 11 '
                .pctSpec.Line (X%, c%)-(c%, X%), Col(c%)
            Case 12 '
                .pctSpec.Circle (128, 128), c% / 2, Col(c%)
            Case 13 '
                q% = c% / 2
                .pctSpec.Line (0 + q%, 0 + q%)-(256 - q%, 256 - q%), Col(c%), B
            Case 14 ' ()
                .pctSpec.PSet (128 + tX, 128 + tY), Col(c%)
            Case 15 ' ()
                If X% = 0 Then tmp = vbBlack Else tmp = Col(c%)
                .pctSpec.Line -(128 + tX, 128 + tY), tmp
            Case 16 '
                .pctSpec.Line (128, 128)-(128 + tX, 128 + tY), Col(c%)
            Case 17 '. 
                .pctSpec.Line -(c%, -Cos(X% / 30) * 254), Col(c%)
            Case 18 '
                .pctSpec.Line (X% * 5, 128)-(X% * 5 + 5, c%), Col(c%), B
            Case 19 ' ()
                .pctSpec.Line (X% * 5, 128)-(X% * 5 + 5, c%), Col(c%), BF
            Case Else
        End Select
    End With
Next X%
End Sub
Public Function Col(CV) As ColorConstants
'        
Select Case frmMain.cmbColor.ListIndex '  
    Case 0 ' -   
        If CV > 0 And CV <= 24 Then Col = vbRed '
        If CV > 24 And CV <= 64 Then Col = vbYellow 'Ƹ
        If CV > 64 And CV <= 192 Then Col = vbGreen '
        If CV > 192 And CV <= 232 Then Col = vbYellow '
        If CV > 232 And CV <= 256 Then Col = vbRed '
        If CV > 256 Then MsgBox " !   " & CV '   ! :)
    Case 1
        Col = vbBlue '
    Case 2
        Col = vbCyan '
    Case 3
        Col = vbGreen ' ( .)
    Case 4
        Col = vbMagenta '
    Case 5
        Col = vbRed '
    Case 6
        Col = vbWhite '
    Case 7
        Col = vbYellow 'Ƹ
    Case 8
        If CV > 0 And CV <= 16 Then Col = RGB(255, 0, 0)
        If CV > 16 And CV <= 32 Then Col = RGB(255, 102, 0)
        If CV > 32 And CV <= 48 Then Col = RGB(255, 204, 0)
        If CV > 48 And CV <= 64 Then Col = RGB(198, 255, 0)
        If CV > 64 And CV <= 80 Then Col = RGB(102, 255, 0)
        If CV > 80 And CV <= 96 Then Col = RGB(0, 255, 0)
        If CV > 96 And CV <= 112 Then Col = RGB(0, 255, 102)
        If CV > 112 And CV <= 128 Then Col = RGB(0, 255, 204)
        If CV > 128 And CV <= 142 Then Col = RGB(0, 204, 255)
        If CV > 142 And CV <= 158 Then Col = RGB(0, 102, 255)
        If CV > 158 And CV <= 174 Then Col = RGB(0, 0, 255)
        If CV > 174 And CV <= 190 Then Col = RGB(102, 0, 255)
        If CV > 190 And CV <= 206 Then Col = RGB(204, 0, 255)
        If CV > 206 And CV <= 224 Then Col = RGB(255, 0, 204)
        If CV > 224 And CV <= 240 Then Col = RGB(255, 0, 102)
        If CV > 240 And CV <= 256 Then Col = RGB(255, 0, 6)
        If CV > 256 Then MsgBox " !   " & CV '   !? :)
    Case Else
End Select
End Function
Public Sub MonitorAudio()
' ()     
Dim WH As WAVEHDR ' WH     

waveInStart hWaveIn '   

Do '   (   )
    With WH '    WH (WAVEHDR)     
        .lpData = VarPtr(WaveData(0)) '  
        .dwBufferLength = 256 '  ( . 256,    128)
        .dwFlags = 0 ' ,   
    End With

    waveInPrepareHeader hWaveIn, WH, Len(WH) ' ,  
    bBufferFull = False ' ,    
    waveInAddBuffer hWaveIn, WH, Len(WH) '   

    Do ' 
        DoEvents '  ...
    Loop Until bBufferFull Or hWaveIn = 0 '       

    waveInUnprepareHeader hWaveIn, WH, Len(WH) '  
    DrawSpect ' 

    DoEvents '      
Loop Until hWaveIn = 0 '  
End Sub
